use pubs
go

select * from sys.procedures
go

-- Need parameters to call these
-- 1. describe_first_result_set for query
select * from sys.dm_exec_describe_first_result_set(
  N'select * from authors', NULL, 1)

-- 2. describe_first_result_set for sproc
select * from sys.dm_exec_describe_first_result_set_for_object(
  OBJECT_ID('dbo.byroyalty'),0)
-- 3. describe_first_result_set for sproc, additional metadata
select * from sys.dm_exec_describe_first_result_set_for_object(
  OBJECT_ID('dbo.byroyalty'),1)

-- 4. describe_first_result_set for query with parameters
exec sp_describe_first_result_set 
 N'select * from authors where au_id = @au_id', NULL, 1

-- 5. describe_parameters for query
exec sp_describe_undeclared_parameters 
 N'select * from authors where au_id = @au_id', NULL